//! Main library entry point for hvcg_biography_openapi_saint implementation.

#![allow(unused_imports)]

use async_trait::async_trait;
use futures::{future, Stream, StreamExt, TryFutureExt, TryStreamExt};
use hyper::server::conn::Http;
use hyper::service::Service;
use log::info;
#[cfg(not(any(target_os = "macos", target_os = "windows", target_os = "ios")))]
use openssl::ssl::SslAcceptorBuilder;
use std::future::Future;
use std::marker::PhantomData;
use std::net::SocketAddr;
use std::sync::{Arc, Mutex};
use std::task::{Context, Poll};
use swagger::{Has, XSpanIdString};
use swagger::auth::MakeAllowAllAuthenticator;
use swagger::EmptyContext;
use tokio::net::TcpListener;

#[cfg(not(any(target_os = "macos", target_os = "windows", target_os = "ios")))]
use openssl::ssl::{SslAcceptor, SslFiletype, SslMethod};

use hvcg_biography_openapi_saint::models;

/// Builds an SSL implementation for Simple HTTPS from some hard-coded file names
pub async fn create(addr: &str, https: bool) {
    let addr = addr.parse().expect("Failed to parse bind address");

    let server = Server::new();

    let service = MakeService::new(server);

    let service = MakeAllowAllAuthenticator::new(service, "cosmo");

    let mut service =
        hvcg_biography_openapi_saint::server::context::MakeAddContext::<_, EmptyContext>::new(
            service
        );

    if https {
        #[cfg(any(target_os = "macos", target_os = "windows", target_os = "ios"))]
        {
            unimplemented!("SSL is not implemented for the examples on MacOS, Windows or iOS");
        }

        #[cfg(not(any(target_os = "macos", target_os = "windows", target_os = "ios")))]
        {
            let mut ssl = SslAcceptor::mozilla_intermediate_v5(SslMethod::tls()).expect("Failed to create SSL Acceptor");

            // Server authentication
            ssl.set_private_key_file("examples/server-key.pem", SslFiletype::PEM).expect("Failed to set private key");
            ssl.set_certificate_chain_file("examples/server-chain.pem").expect("Failed to set cerificate chain");
            ssl.check_private_key().expect("Failed to check private key");

            let tls_acceptor = Arc::new(ssl.build());
            let mut tcp_listener = TcpListener::bind(&addr).await.unwrap();
            let mut incoming = tcp_listener.incoming();

            while let (Some(tcp), rest) = incoming.into_future().await {
                if let Ok(tcp) = tcp {
                    let addr = tcp.peer_addr().expect("Unable to get remote address");
                    let service = service.call(addr);
                    let tls_acceptor = Arc::clone(&tls_acceptor);

                    tokio::spawn(async move {
                        let tls = tokio_openssl::accept(&*tls_acceptor, tcp).await.map_err(|_| ())?;

                        let service = service.await.map_err(|_| ())?;

                        Http::new().serve_connection(tls, service).await.map_err(|_| ())
                    });
                }

                incoming = rest;
            }
        }
    } else {
        // Using HTTP
        hyper::server::Server::bind(&addr).serve(service).await.unwrap()
    }
}

#[derive(Copy, Clone)]
pub struct Server<C> {
    marker: PhantomData<C>,
}

impl<C> Server<C> {
    pub fn new() -> Self {
        Server{marker: PhantomData}
    }
}


use hvcg_biography_openapi_saint::{
    Api,
    AddSaintResponse,
    DeleteSaintResponse,
    GetAllSaintsResponse,
    GetSaintByIdResponse,
    UpdateSaintResponse,
};
use hvcg_biography_openapi_saint::server::MakeService;
use std::error::Error;
use swagger::ApiError;

#[async_trait]
impl<C> Api<C> for Server<C> where C: Has<XSpanIdString> + Send + Sync
{
    /// Add new saint
    async fn add_saint(
        &self,
        saint: models::Saint,
        context: &C) -> Result<AddSaintResponse, ApiError>
    {
        let context = context.clone();
        info!("add_saint({:?}) - X-Span-ID: {:?}", saint, context.get().0.clone());
        Err("Generic failuare".into())
    }

    /// Deletes a saint
    async fn delete_saint(
        &self,
        context: &C) -> Result<DeleteSaintResponse, ApiError>
    {
        let context = context.clone();
        info!("delete_saint() - X-Span-ID: {:?}", context.get().0.clone());
        Err("Generic failuare".into())
    }

    /// Get all saints
    async fn get_all_saints(
        &self,
        gender: Option<models::Gender>,
        display_name: Option<String>,
        offset: Option<i32>,
        count: Option<i32>,
        context: &C) -> Result<GetAllSaintsResponse, ApiError>
    {
        let context = context.clone();
        info!("get_all_saints({:?}, {:?}, {:?}, {:?}) - X-Span-ID: {:?}", gender, display_name, offset, count, context.get().0.clone());
        Err("Generic failuare".into())
    }

    /// Find saint by ID
    async fn get_saint_by_id(
        &self,
        id: uuid::Uuid,
        context: &C) -> Result<GetSaintByIdResponse, ApiError>
    {
        let context = context.clone();
        info!("get_saint_by_id({:?}) - X-Span-ID: {:?}", id, context.get().0.clone());
        Err("Generic failuare".into())
    }

    /// Update an existing saint
    async fn update_saint(
        &self,
        saint: models::Saint,
        context: &C) -> Result<UpdateSaintResponse, ApiError>
    {
        let context = context.clone();
        info!("update_saint({:?}) - X-Span-ID: {:?}", saint, context.get().0.clone());
        Err("Generic failuare".into())
    }

}
